/*
NAME:       Multicast sender
SYNOPSIS:    McastSend <multicast group> <port>
DESCRIPTION:    The program creates a datagram socket in the inet 
                domain. It sends data to a multicast group and gets
                an echo of the message.
*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

#define BUFSIZE 1024
char buf[BUFSIZE];
FILE *fpt3;

int main( int argc, char * argv[] )
{
   int   s;
   struct   sockaddr_in mc_group;
   struct sockaddr_in addr;
   int rc;
   /* linux */
   unsigned long int GroupIP;
   /* Solaris
      in_addr_t GroupIP; */
   char loop, ttl;

   if (argc != 4) {
     fprintf(stderr, "Usage : %s <multicast group> <port>\n",argv[0]);
     exit(0);
   }

   if( (GroupIP = inet_addr(argv[1]))== -1)
       printf("error in inet_addr\n");
   

   mc_group.sin_family = AF_INET; 
   mc_group.sin_port = htons(atoi(argv[2]));
   mc_group.sin_addr.s_addr = GroupIP;

   s = socket (PF_INET,SOCK_DGRAM,0);

   /*
      By default, messages sent to the multicast group are looped 
      back to the local host. this function disables that.
      loop = 1  means enable loopback 
      loop = 0  means disable loopback 
      NOTE : by default, loopback is enabled
      */       
   loop = 1;
   if( setsockopt(s,IPPROTO_IP,IP_MULTICAST_LOOP,(char *) &loop,
		  sizeof(u_char)) == -1 )
   {
     printf("error in setting loopback\n");
   }

   /*
      set the Time-To-Live value
      */
   ttl = 0;
   if( setsockopt(s,IPPROTO_IP,IP_MULTICAST_TTL,(char *) &ttl,
		  sizeof(u_char)) == -1 )
   {
     printf("error in setting loopback value\n");
   }


       fpt3=fopen(argv[3],"r");

  while(!feof(fpt3)){
  	fread(buf, sizeof(buf),1,fpt3);
  	
  	if (sendto(s, buf, sizeof(buf), 0, (struct sockaddr*)&mc_group,
		sizeof(mc_group)) <0 )
	 perror("sending datagram message");
    usleep(500);

  }
  if (sendto(s, "STOP", 4, 0, (struct sockaddr*)&mc_group,
		sizeof(mc_group)) <0 )
	 perror("sending datagram message");
    usleep(500);

  system("killall -INT Serverclient");





  fclose(fpt3);
  //printf ("EOF... exit\n");
  close(s);

  	

  exit (0);






}






